Imports System.Xml.Serialization
Imports System.IO

<Serializable()> Public Class controlsDef
    Public formDefs As New List(Of formDef)

    Public Shared Function load(ByVal f As String) As controlsDef
        Dim xs As New XmlSerializer(GetType(controlsDef))
        Dim sr As New StreamReader(f)
        Return CType(xs.Deserialize(sr), controlsDef)
    End Function

    ''' <summary>
    ''' Unused in the software; only for testing.
    ''' </summary>
    Public Sub save(ByVal f As String)
        Dim xs As New XmlSerializer(GetType(controlsDef))
        Dim sw As New StreamWriter(f)
        xs.Serialize(sw, Me)
        sw.Close()
    End Sub

    Public Function tryGetAssociatedField(ByVal frm As String, ByVal n As String) As String
        Dim foundAssociations As New List(Of fieldAssociation)
        For Each fd As formDef In formDefs
            If fd.formName = frm Then
                For Each fa As fieldAssociation In fd.fieldAssociations
                    If fa.labelName = n Then
                        foundAssociations.Add(fa)
                    End If
                Next
            End If
        Next
        If foundAssociations.Count = 1 Then
            Return foundAssociations(0).fieldName
        Else
            Return ""
        End If
    End Function
End Class
